/********************************************************************************/
/*                                                                              */
/*              dependmain.cxx                                                  */
/*                                                                              */
/*      Main program for dependency analyzer                                    */
/*                                                                              */
/********************************************************************************/


#include "depend_local.H"

#include <fstream.h>


/********************************************************************************/
/*                                                                              */
/*      main -- main program                                                    */
/*                                                                              */
/********************************************************************************/


main(int argc,const char ** argv)
{
   ConstText file = NULL;
   Integer i;

   for (i = 1; i < argc; ++i) {
      if (argv[i][0] == '-') {
         cerr << "DEPEND: Invalid option '" << argv[i] << "'" << endl;
         exit(1);
       }
      else if (file == NULL) {
         file = argv[i];
       }
      else {
         cerr << "DEPEND: Only one file can be specified" << endl;
         exit(2);
       }
    }

   DependNodeSet dns = new DependNodeSetInfo;

   if (file == NULL) dns->readNodes(cin);
   else {
      ifstream ifs(file);

      if (!ifs) {
         cerr << "DEPEND: Can't open input file '" << file << "'" << endl;
         exit(3);
       }

      dns->readNodes(ifs);
    }

   dns->topSort(cout);

   delete dns;

   return 0;
}




/* end of dependmain.cxx */

