/********************************************************************************/
/*                                                                              */
/*              dependnode.cxx                                                  */
/*                                                                              */
/*      Methods for dependency nodes                                            */
/*                                                                              */
/********************************************************************************/


#include "depend_local.H"




/********************************************************************************/
/*                                                                              */
/*      DependNodeInfo constructors/destructors                                 */
/*                                                                              */
/********************************************************************************/


DependNodeInfo::DependNodeInfo(String nm)
{
   node_name = nm;
   num_link = 0;
}



DependNodeInfo::~DependNodeInfo()                               { }




/********************************************************************************/
/*                                                                              */
/*      DependNodeInfo access methods                                           */
/*                                                                              */
/********************************************************************************/


ConstText
DependNodeInfo::name() const            { return node_name.data(); }


Integer
DependNodeInfo::numLink() const         { return num_link; }



/********************************************************************************/
/*                                                                              */
/*      DependNodeInfo link management methods                                  */
/*                                                                              */
/********************************************************************************/


void
DependNodeInfo::addLink(DependNode dn)
{
   depend_on.push_back(dn);
   dn->updateLinkCount(1);
}


Integer
DependNodeInfo::updateLinkCount(Integer by)
{
   num_link += by;
   return num_link;
}


DependNodeVectorIter
DependNodeInfo::links()                 { return depend_on.begin(); }


DependNodeVectorIter
DependNodeInfo::linksEnd()              { return depend_on.end(); }




/* end of dependnode.cxx */
